"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ITopicPermissionSchema = void 0;
// Generated by ts-to-zod
const zod_1 = require("zod");
const ObjectMeta_schema_1 = require("@soft-stech/apimachinery/apis/meta/v1/ObjectMeta.schema");
/**
 * TopicPermission is the Schema for the topicpermissions API
 */
exports.ITopicPermissionSchema = zod_1.z.object({
    /**
     * APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
     */
    "apiVersion": zod_1.z.literal("rabbitmq.com/v1beta1"),
    /**
     * Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
     */
    "kind": zod_1.z.literal("TopicPermission"),
    "metadata": ObjectMeta_schema_1.iObjectMetaSchema.optional(),
    /**
     * TopicPermissionSpec defines the desired state of TopicPermission
     */
    "spec": zod_1.z.object({
        /**
         * Permissions to grant to the user to a topic exchange; required property.
         */
        "permissions": zod_1.z.object({
            /**
             * Name of a topic exchange; required property; cannot be updated.
             */
            "exchange": zod_1.z.string().optional(),
            "read": zod_1.z.string().optional(),
            "write": zod_1.z.string().optional()
        }),
        /**
         * Reference to the RabbitmqCluster that both the provided user and vhost are. Required property.
         */
        "rabbitmqClusterReference": zod_1.z.object({
            /**
             * Secret contains the http management uri for the RabbitMQ cluster. The Secret must contain the key `uri`, `username` and `password` or operator will error. Have to set either name or connectionSecret, but not both.
             */
            "connectionSecret": zod_1.z.object({
                /**
                 * Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
                 */
                "name": zod_1.z.string().optional()
            }).optional(),
            /**
             * The name of the RabbitMQ cluster to reference. Have to set either name or connectionSecret, but not both.
             */
            "name": zod_1.z.string().optional(),
            /**
             * The namespace of the RabbitMQ cluster to reference. Defaults to the namespace of the requested resource if omitted.
             */
            "namespace": zod_1.z.string().optional()
        }),
        /**
         * Name of an existing user; must provide user or userReference, else create/update will fail; cannot be updated.
         */
        "user": zod_1.z.string().optional(),
        /**
         * Reference to an existing user.rabbitmq.com object; must provide user or userReference, else create/update will fail; cannot be updated.
         */
        "userReference": zod_1.z.object({
            /**
             * Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?
             */
            "name": zod_1.z.string().optional()
        }).optional(),
        /**
         * Name of an existing vhost; required property; cannot be updated.
         */
        "vhost": zod_1.z.string()
    }).optional(),
    /**
     * TopicPermissionStatus defines the observed state of TopicPermission
     */
    "status": zod_1.z.object({
        "conditions": zod_1.z.array(zod_1.z.object({
            /**
             * The last time this Condition status changed.
             * @format date-time
             */
            "lastTransitionTime": zod_1.z.string().datetime().optional().nullable(),
            /**
             * Full text reason for current status of the condition.
             */
            "message": zod_1.z.string().optional(),
            /**
             * One word, camel-case reason for current status of the condition.
             */
            "reason": zod_1.z.string().optional(),
            /**
             * True, False, or Unknown
             */
            "status": zod_1.z.string(),
            /**
             * Type indicates the scope of the custom resource status addressed by the condition.
             */
            "type": zod_1.z.string()
        })).optional(),
        /**
         * observedGeneration is the most recent successful generation observed for this TopicPermission. It corresponds to the TopicPermission's generation, which is updated on mutation by the API Server.
         * @format int64
         */
        "observedGeneration": zod_1.z.number().optional()
    }).optional()
});
